$Name Program do obsugi akcesoriw z platformy demonstracyjnej

;W aplikacji bior udzia 2 sterowniki PLUTO: 
;- B20 (8 wej bezpieczestwa 4 kat., 8 wejcio/wyj, 4 wyjcia bezpieczestwa 4 kat.)
;- B16 (8 wej bezpieczestwa 4 kat., 8 wejcio/wyj, bez wyj bezpieczestwa)
;Poaczone s ze sob szyn SAFEBUS o przepustowoci 1Mbit,
;kady wyposaony w identyfikator adresowy ID-FIX, pod porty I/O podaczone s:
;- kurtyna bezpieczestwa 4 kategorii 2 kanaowa z autoresetem bez EDM
;- 2 przyciski/lapki resetu
;- 4 portowa wyspa bezpieczestwa typu TINA 4A z przyczon poprzez adaptor TINA 6A listw 
;bezp. oraz E-stopem typu SMILE
;- 1 czujnik drzwiowy bezstykowy 4 kat. IP69K typu EDEN
;- 1 E-stop 2-kanaowy
;- 2 kule oburcznego sterowania
;- 1 wcznik zezwolenia JSHD4
;- 2 wentylatory i 2 lampki symulujce odbiorniki
;- 4 przeczniki bistabilne
;HASO: contra

#Include <func05.fps>
#Include <HMI.fps>

! Id_Pluto:0=00000B63D2AA
! Id_Pluto:1=00000A412EDF
! Can_Baud=1000

! I0.0=E_STOP_static_0                  ;stop awaryjny sygna statyczny
! I0.1=E_STOP_dynamic_1                 ;stop awaryjny sygna dynamiczny
! I0.2=EDEN_dynamic_2                   ;wejcie z czujnika EDEN dynamiczne
! I0.3=E_STOP_SMILE                     ;wejcie sygnau dynamicznego z e-stopw smile tina
! I0.4=JSHD4_dynamic_4                  ;3 pozycyjny wycznik sygna statyczny
! I0.5=JSHD4_static_5                   ;3 pozycyjny wycznik sygna statyczny
! I0.6=BALL_dynamic_6                   ;2 rczne sterowanie sygna dynamiczny
! I0.7=BALL_dynamic_7                   ;2 rczne sterowanie sygna dynamiczny
! I0.11=BALL_static_11                  ;2 rczne sterowanie sygna statyczny
! I0.12=BALL_static_12                  ;2 rczne sterowanie sygna statyczny
! I0.13=PORT_13                         ;port zewntrzny
! I0.14=SWITCH_14                       ;przecznik 1
! I0.15=SWITCH_15                       ;przecznik 2
! I0.16=JSHD4_SWF_16                    ;3 pozycyjny wycznik przycisk przd statyczny
! I0.17=JSHD4_SWT_17                    ;3 pozycyjny wycznik przycisk grny statyczny
! Q0.0=FAN_0                            ;wentylator nr 1
! Q0.1=FAN_1                            ;wentylator nr 2
! Q0.2=IND_FAN_0                        ;lampka wentylatora nr 1
! Q0.3=IND_FAN_1                        ;lampka wentylatora nr 2
! GM0.0=WTARGNECIEB20                   ;wtargnicie w stref sterownika B16
! GM0.1=ESTOP                           ;stan stopu awaryjnego
! GM0.2=ZMIANA_USTAWIE                 ;sygna informujcy o zmianie ustawie maszyny
! GM0.3=RESET_STREFY                    ;sygna resetu dla strefy maszyny
! GM0.4=JSHD4_zezwolenie                ;zezwolenie na wysterowanie ruchu za pomoz JSHD4
! GM0.5=JSTD_zezwolenie                 ;zezwolenie na prac sterowan przez JSTD
! GM0.6=START_JSHD4                     ;zezwolenie z wcznika trjpozycyjnego
! GM0.7=START_JSTD                      ;zezwolenie z 2-rcznego sterowania
! GM0.8=EDEN                            ;aktywacja kracwki EDEN
! GM0.9=BALLS_CON                       ;
! GM0.10=BEZCZYNNOSCB20                 ;sygna o braku dziaa przez wicej niz 30 sekund
! GM0.11=ESTOP1                         ;
! I1.0=TINA_0_dynamic                   ;wejcie sygnau testujcego dynamicznego z TINY
! I1.1=TINA_INFO_1_static               ;wejcie sygnau testujcego statycznego z TINY
! I1.2=TINA_INFO_2_static               ;wejcie sygnau testujcego statycznego z TINY
! I1.3=TINA_INFO_3_static               ;wejcie sygnau testujcego statycznego z TINY
! I1.4=TINA_INFO_4_static               ;wejcie sygnau testujcego statycznego z TINY
! I1.5=OSSD1                            ;wejcie sygnau testujcego kurtyny
! I1.6=OSSD2                            ;wejcie sygnau testujcego kurtyny
! I1.7=SWITCH_7                         ;wejcie z przecznika 7
! I1.11=SWITCH_11                       ;wejcie z przecznika 11
! I1.12=LAMP_12_dynamic                 ;wejcie z lampki kontrolnej dynamiczny
! I1.13=LAMP_13_dynamic                 ;wejcie z lampki kontrolnej dynamiczny
! GM1.0=WTARGNICIEB16                  ;wtargnicie w stref sterownika B16
! GM1.1=TINA4A                          ;aktywacja jednego z urzadze podczonych pod koncentrator TINA4A
! GM1.2=KURTYNA                         ;stan kurtyny
! GM1.3=BEZCZYNNOSCB16                  ;zbyt dugi postj
! GM1.9=RESET_B20                       ;
! GM1.10=RESET_B16                      ;
! GM1.11=AUTOMAT                        ;wczenie cyklu automatycznego

! Pgm_Pluto:0
! Ext_comm:0=Modbus_ASCII
! Ext_comm:1=Modbus_ASCII
! Ext_comm:2=Modbus_ASCII
! Ext_comm:3=Modbus_ASCII
;typ B20

! I0.0,Static
! I0.1,A_Pulse,Non_Inv
! I0.2,A_Pulse
! I0.3,B_Pulse
! I0.4,A_Pulse,Non_Inv
! I0.5,Static
! I0.6,A_Pulse,Non_Inv
! I0.7,A_Pulse,Non_Inv
! I0.11,Static
! I0.12,Static
! I0.14,Static
! I0.15,Static
! I0.16,Static
! I0.17,Static
! Q0.10,A_Pulse
! Q0.13,B_Pulse

! Q0.10=DYNAMIC_0A                      ;generator przebiegu dynamicznego A
! Q0.13=DYNAMIC_B                       ;generator przebiegu dynamicznego B
! M0.0=RESET_NEED                       ;potrzeba przeprowadzenia resetu
! M0.1=FE_STOP                          ;fault of emergency stop
! M0.2=FUN_0_JOB                        ;zezwolenie na uruchomienie silnika 0
! M0.3=MEDEN                            ;Memory for eden state
! M0.4=BRAK_AWARII                      ;stan systemu - brak awarii
! M0.5=FUN_0_JOB_JSHD4                  ;wczenie silnika z wycznika 3 pozycyjnego
! M0.6=FUN_0_JOB_JSTD                   ;wczenie silnika z wycznikw kulowych
! M0.7=EDEN_MUTE                        ;muting edenw
! R0.0=komunikat                        ;
! R0.1=licznik                          ;
! R0.2=komunikat1                       ;
! R0.3=komunikat2                       ;
! R0.4=komunikat3                       ;
! R0.5=komunikat4                       ;
! R0.6=komunikat5                       ;
! R0.7=licznik2                         ;
! R0.8=komunikatow                      ;
! R0.9=czas                             ;
! R0.10=zmienna_X                       ;
! R0.11=czas_bezczynnosci_b20           ;czas po jakim nastepuje bezczynnosc


S0.0_0
(czas_bezczynnosci_b20=2000)=SM_SysInit
FAN_0=WTARGNECIEB20*ESTOP*(START_JSHD4+SWITCH_14)
IND_FAN_0=FAN_0*SM_FastFlash
IND_FAN_1=FAN_1*SM_FastFlash
FAN_1=WTARGNICIEB16*ESTOP*(START_JSTD+SWITCH_15+AUTOMAT)*(KURTYNA+SWITCH_11)
WTARGNECIEB20=ResetT(EDEN_dynamic_2*ESTOP*/BEZCZYNNOSCB20,RESET_B20,1,RESET_STREFY)
;nadzor strefy B20
ESTOP=TC1T(E_STOP_dynamic_1*E_STOP_SMILE,E_STOP_static_0*E_STOP_SMILE,1)
;an Stopu awaryjnego
BEZCZYNNOSCB20=/START_JSHD4*/SWITCH_14*/RESET_B20*T(czas_bezczynnosci_b20)*/T(1s00)
;Wymuszenie resetu po 30 czasie nieaktywnoci maszyny
START_JSTD=Twohand1(BALL_dynamic_6,BALL_dynamic_7,BALL_static_11,BALL_static_12,/SWITCH_15)
;Sygna wczenia silnika roboczego z kul 2-rcznego sterowania
;
;
R(BALLS_CON)=(/BALL_dynamic_7+/BALL_static_12)*/START_JSTD*T(3s00)
;kontrola pracy kul i podaczenia lub zblokowania przyciskw
S(BALLS_CON)=TC1T(BALL_dynamic_7,BALL_static_12,1)
;kontrola podczenia kul 2 -rcznego sterowania
START_JSHD4=TC1T(JSHD4_dynamic_4,JSHD4_static_5,/SWITCH_14)
;Sygna wczenia silnika roboczego za pomoc trjpozycyjnego wcznika zezwolenia
;
;
JSHD4_zezwolenie=ResetT(/SWITCH_14,LAMP_12_dynamic,/START_JSHD4,0)
;przeczenie w trybu sterowania prac na JSHD4
JSTD_zezwolenie=ResetT(SWITCH_14,RESET_B20,/START_JSTD,0)
;przeczenie w trybu sterowania prac na JSTD
BRAK_AWARII=Divide(SR_SupplVolt,10,zmienna_X)
;dzielenie wskazania napiecia zasilania
(SR_PlutoDisplay=zmienna_X)=SM_Button*BRAK_AWARII*(zmienna_X<200)
;wyswietlanie napicia sygnau OSSD kurtyny
(SR_PlutoDisplay=komunikat)=(/ESTOP+/BALLS_CON+/EDEN_dynamic_2)*(komunikat>=200)
;wyswietlanie komunikatow o bledach
(licznik2++)=SM_10Hz
;licznik wyswietlacza
(czas=20)
;Czas wywietlania komunikatu
(komunikatow=3)
;ilo komunikatw
(licznik2=0)=(licznik2>czas)
;licznik wyswietlacza
(licznik++)=(licznik2=czas)*/T(0s02)*(licznik<=komunikatow)
;licznik wyswietlacza
(licznik=0)=(licznik>komunikatow)
;licznik wyswietlacza
(komunikat=211)=/ESTOP*(licznik=1)
;Sygna o wcinitym E-STOP
(licznik++)=ESTOP*(licznik=1)
;Sygna o wcinitym E-STOP
(komunikat=221)=/BALLS_CON*(licznik=2)
;Sygna o otwartych drzwiach KOMORY
(licznik++)=BALLS_CON*(licznik=2)
;Sygna o otwartych drzwiach KOMORY
(komunikat=231)=/EDEN_dynamic_2*(licznik=3)
;Sygna o bedzie kracwek GORA/DOL
(licznik++)=EDEN_dynamic_2*(licznik=3)
;Sygna o bedzie kracwek GORA/DOL

! Pgm_Pluto:1
! Ext_comm:0=Modbus_ASCII
! Ext_comm:1=Modbus_ASCII
! Ext_comm:2=Modbus_ASCII
! Ext_comm:3=Modbus_ASCII
;typ B16

! I1.0,A_Pulse
! I1.1,Static
! I1.2,Static
! I1.3,Static
! I1.4,Static
! I1.5,Static
! I1.6,Static
! I1.7,Static
! I1.11,Static
! Q1.10,A_Pulse
! Q1.14,Static
! Q1.15,Static
! Q1.16,Static
! Q1.17,Static
! IQ1.12,A_Pulse
! IQ1.13,A_Pulse

! Q1.10=DYNAMIC_A                       ;sygna dynamiczny A
! Q1.12=LAMPKA_RESET                    ;
! Q1.13=LAMPKA_SILNIK                   ;
! Q1.14=ZASILANIE_KURTYNA               ;waczanie/wyczanie kurtyny
! Q1.15=RESET_KURTYNA                   ;wyjcie resetujce kurtyn
! Q1.16=MUTING_A                        ;wczenie mutingu A
! Q1.17=MUTING_B                        ;wczenie mutingu B
! M1.0=BRAK_WTARGNIECIA                 ;informacja o braku obcych elementw w strefie niebezpiecznej
! M1.1=AWARIA_IND                       ;wskazanie do resetu
! M1.2=WTARGNIECIE_IND                  ;wskazanie wtargniecia
! M1.3=Przeliczanie                     ;wynik przeliczania
! M1.4=WTARGNIECIE_KURTYNA              ;sygna o zakceniu pola dziaania kurtyny
! M1.5=PANEL0                           ;zmienna ustawiana z panela
! M1.6=PANEL1                           ;zmienna ustawiana z panela
! M1.7=PANEL2                           ;zmienna ustawiana z panela
! M1.8=PANEL3                           ;zmienna ustawiana z panela
! M1.9=PANEL4                           ;zmienna ustawiana z panela
! M1.10=PANEL5                          ;zmienna ustawiana z panela
! M1.11=PANEL6                          ;zmienna ustawiana z panela
! M1.12=PANEL7                          ;zmienna ustawiana z panela
! M1.13=PANEL8                          ;zmienna ustawiana z panela
! R1.0=zmienna_A                        ;zmiennna do oblicze
! R1.1=zmienna_B                        ;zmienna do oblicze
! R1.2=zmienna_C                        ;zmienna do oblicze
! R1.3=JSHD4_starts                     ;ilo uruchomie za pomoca JSHD4
! R1.4=JSTD_starts                      ;ilo uruchomie za pomoc JSTD
! R1.5=komunikaty                       ;
! R1.6=licznik0                         ;
! R1.7=licznik1                         ;
! R1.8=czas0                            ;
! R1.9=komunikatow0                     ;
! R1.10=ILOSC_CYKLI                     ;ilosc cykli zadawana z panela
! R1.11=czas_bezczynnosci_b16           ;
! R1.12=LICZNIK_CYKLI                   ;
! R1.13=R1                              ;
! R1.14=R2                              ;


S1.0_0
(czas_bezczynnosci_b16=3000)=SM_SysInit
(ILOSC_CYKLI=10)=SM_SysInit
(LICZNIK_CYKLI=0)=SM_SysInit
PANEL0=Ext_Sig(0,0)
;Ustawienie bitu pamieci z panela HMI
PANEL1=Ext_Sig(1,0)
;Ustawienie bitu pamieci z panela HMI
PANEL2=Ext_Sig(2,0)
;Ustawienie bitu pamieci z panela HMI
PANEL3=Ext_Sig(3,0)
;Ustawienie bitu pamieci z panela HMI
PANEL4=Ext_Sig(4,0)
;Ustawienie bitu pamieci z panela HMI
PANEL8=Ext_Sig(5,0)
;Ustawienie bitu pamieci z panela HMI
PANEL5=Ext_Val(0,0,czas_bezczynnosci_b16)
;Ustawienie wartoci rejestru sterownika z panela HMI
PANEL6=Ext_Val(1,0,ILOSC_CYKLI)
;Ustawienie wartoci rejestru sterownika z panela HMI
PANEL7=Ext_Val(2,0,R1)
;Ustawienie wartoci rejestru sterownika z panela HMI
(ILOSC_CYKLI++)=SM_Button
(LICZNIK_CYKLI++)=P(/KURTYNA)*ZASILANIE_KURTYNA*/SWITCH_14
;uruchomienie cyklu po ilosci przerwa kurtyny
AUTOMAT=(LICZNIK_CYKLI=ILOSC_CYKLI)
;Wczenie automatu po okreslonej ilosci przerwa kurtyny
(LICZNIK_CYKLI=0)=(LICZNIK_CYKLI>ILOSC_CYKLI)
;Wczenie automatu po okreslonej ilosci przerwa kurtyny
RESET_KURTYNA=SWITCH_7+PANEL0
;reset kurtyny
LAMPKA_RESET=RESET_STREFY
KURTYNA=TC1T(OSSD1,OSSD2,ZASILANIE_KURTYNA)
ZASILANIE_KURTYNA=/SWITCH_11+PANEL1
;Zasilanie kurtyny
WTARGNICIEB16=ResetT((TINA_0_dynamic+PANEL8)*ESTOP*BALLS_CON*/BEZCZYNNOSCB16*(KURTYNA+SWITCH_11),RESET_B16,1,LAMPKA_SILNIK)
;Ukad resetu sterownika B16
RESET_B16=LAMP_13_dynamic+PANEL2
;RESET B16
RESET_B20=LAMP_12_dynamic+PANEL3
;RESET B16
BEZCZYNNOSCB16=/START_JSTD*/RESET_B16*/SWITCH_15*T(czas_bezczynnosci_b16)*/T(1s00)
;Wymuszenie resetu po 30 czasie nieaktywnoci maszyny
(zmienna_A++)=P(/KURTYNA)
;zliczanie numeru ilosci przerwan kurtyny
(SR_PlutoDisplay=zmienna_A)=/KURTYNA*SWITCH_7
;wyswietlanie ilosci przerwa kurtyny
Przeliczanie=Divide(SR_I5_Volt,10,zmienna_B)
;dzielenie wskazania napiecia na wejciu I5
(SR_PlutoDisplay=zmienna_B)=/SWITCH_11*SM_Button*Przeliczanie*(zmienna_B<200)
;wyswietlanie napicia sygnau OSSD kurtyny
(zmienna_A=0)=RESET_B16*T(2s00)
;reset licznika
(SR_PlutoDisplay=komunikaty)=(/ESTOP+/TINA_0_dynamic+/KURTYNA*/SWITCH_11*/SWITCH_7)*(komunikaty>=200)
;wyswietlanie komunikatow o bledach
(licznik1++)=SM_10Hz
;licznik wyswietlacza
(czas0=20)
;Czas wywietlania komunikatu
(komunikatow0=3)
;ilo komunikatw
(licznik1=0)=(licznik1>czas0)
;licznik wyswietlacza
(licznik0++)=(licznik1=czas0)*/T(0s02)*(licznik0<=komunikatow0)
;licznik wyswietlacza
(licznik0=0)=(licznik0>komunikatow0)
;licznik wyswietlacza
(komunikaty=211)=/ESTOP*(licznik0=1)
;Sygna o wcinitym E-STOP
(licznik0++)=ESTOP*(licznik0=1)
;Sygna o niezakconym E-STOP
(komunikaty=241)=/KURTYNA*(licznik0=2)
;Sygna o wejciu w pole kurtyny wietlnej
(licznik0++)=KURTYNA*(licznik0=2)
;Sygna o wolnym polu kurtyny wietlnej
(komunikaty=251)=/TINA_0_dynamic*(licznik0=3)
;Sygna o aktywacji czujnikw podpitych pod koncentrator tina4A
(licznik0++)=TINA_0_dynamic*(licznik0=3)
;Sygna o niezakconym koncentratorze tina4A
